"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const npm_sm_1 = require("npm-sm");
const commands_1 = require("../commands");
const chalk = require('chalk');
// command - string, cli.inputs[0]
// cli - meow object
function main(command, cli) {
    if (cli.flags.debug) {
        console.log(chalk.bgMagenta('[TS-SM] DEBUG:'), chalk.magenta('Command called ' + command));
    }
    return run(command, cli);
}
exports.main = main;
function run(command, cli) {
    switch (command) {
        case 'build':
            return commands_1.buildTsRun(cli);
        case 'link':
            return npm_sm_1.npmLinkRun(cli);
        case 'version':
            return npm_sm_1.npmVersionRun(cli);
        case 'dist-tag':
            return npm_sm_1.npmDistTagRun(cli);
        case 'publish':
            return npm_sm_1.npmPublishRun(cli, { buildCommand: commands_1.buildCommand });
        default:
            throw new Error(`You are using unknown command '${command}', 
    please refer to help for a list of available commands`);
    }
}
